Loading...
Searching...
No Matches
BALL::VIEW::MolecularStructure Class Reference
Visualisation » Modular Widgets

`#include <BALL/VIEW/WIDGETS/molecularStructure.h>`

Inheritance diagram for BALL::VIEW::MolecularStructure:

## Public Types

enum | { AMBER_FF = 0 , CHARMM_FF , MMFF94_FF }
Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector

## Public Member Functions

Constructors
| MolecularStructure (QWidget *parent=0, const char *name=0)
| MolecularStructure (const MolecularStructure &m)
| only needed for Python Interface, dont call it!
Destructors
virtual | ~MolecularStructure ()
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
virtual void | clear ()
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
virtual void | addToolBarEntries (QToolBar *main_tb)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
virtual void | initializePreferencesTab (Preferences &preferences)
virtual void | finalizePreferencesTab (Preferences &preferences)
virtual void | applyPreferences ()
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual void | finalizeWidget (MainControl &main_control)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()
virtual bool | isValid () const

## Accessors: inspectors and mutators

virtual void | onNotify (Message *message)
virtual void | checkMenu (MainControl &main_control)
virtual void | initializeWidget (MainControl &main_control)
ForceField & | getForceField ()
Position | getForceFieldID ()
AmberFF & | getAmberFF ()
CharmmFF & | getCharmmFF ()
MMFF94 & | getMMFF94 ()
AmberConfigurationDialog & | getAmberConfigurationDialog ()
| Get an instance of an dialog to setup the AMBER forcefield.
CharmmConfigurationDialog & | getCharmmConfigurationDialog ()
| Get an instance of an dialog to setup the CHARMM forcefield.
MMFF94ConfigurationDialog & | getMMFF94ConfigurationDialog ()
virtual void | fetchPreferences (INIFile &inifile)
virtual void | writePreferences (INIFile &inifile)
MolecularDynamicsDialog & | getMDSimulationDialog ()
MinimizationDialog & | getMinimizationDialog ()
FDPBDialog * | getFDPBDialog ()
AssignBondOrderConfigurationDialog & | getBondOrderDialog ()
const AssignBondOrderConfigurationDialog & | getBondOrderDialog () const
AssignBondOrderResultsDialog & | getBondOrderResultsDialog ()
const AssignBondOrderResultsDialog & | getBondOrderResultsDialog () const
void | centerCamera (Composite *composite=0)
void | buildBonds ()
void | buildEndcaps ()
void | runBondOrderAssignment (bool show_dialog=true)
void | showBondOrderAssignmentResults (AssignBondOrderProcessor &bop)
void | addHydrogens ()
virtual bool | checkResidue ()
virtual void | createGridFromDistance ()
| Create a RegularData3D instance with the distance from the geometric center.
virtual void | createGridFromCameraDistance ()
virtual void | calculateSecondaryStructure ()
| Calculate the secondary structure for a protein.
virtual void | mapProteins ()
| Map two Proteins and apply the resulting transformation matrix.
virtual void | calculateRMSD ()
| Calculate the RMSD between two Molecules.
void | buildPeptide ()
| Build a Peptide from a amino acid sequence.
bool | generateCrystal (bool show=true)
| Build a crystal packing for a loaded system.
void | calculateHBonds ()
| Calculate the H-Bonds for a Protein.
void | calculateRamachandranPlot ()
| Calculate a Ramachandran Plot.
void | calculateForceFieldEnergy ()
| Calculate the energy for the currently selected force field.
void | runMinimization (bool show_dialog_=true)
| Run a energy minization with the currently selected force field.
void | MDSimulation (bool show_dialog_=true)
| Perfomr a molecular dynamics simulation with the currently selected force field.
void | showAmberForceFieldOptions ()
| Show the dialog to setup the AMBER force field.
void | showCharmmForceFieldOptions ()
| Show the dialog to setup the CHARMM force field.
void | showMMFF94ForceFieldOptions ()
void | chooseAmberFF ()
| Slot for a menu entry to select the AMBER force field.
void | chooseCharmmFF ()
| Slot for a menu entry to select the CHARMM force field.
void | chooseMMFF94 ()
| Slot for a menu entry to select the MMFF94 force field.
void | chooseForceField (Position nr)
void | setupForceField ()
| Show a dialog to setup the currently selected force field.
bool | calculateFDPB (bool show=true)

## Additional Inherited Members

static void | registerWidget (ModularWidget *mwidget)
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_

## Detailed Description

MolecularStructure provides means to modify molecular structures and do several calculations. To do so, it contains the MMFF94, AMBER and CHARMM forcefields and dialogs to do the setup. The widget itself is invisible, but it has several menu entries, e.g.:

- checkResidue
- centerCamera
- buildBonds
- assignBondOrders
- addHydrogens
- createGridFromDistance
- calculateSecondaryStructure This class is also necessary to add certain properties to new Composite objects, which were opened with the MolecularFileDialog. So it reacts to Messages itself and converts some to other Message objects. Further it converts the geometric selection sent by Scene to a molecular selection whose objects can be given a new graphical representation by the DisplayProperties dialog. See onNotify for information concerning the conversion mechanism.

Definition at line 90 of file molecularStructure.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
AMBER_FF |
CHARMM_FF |
MMFF94_FF |

Definition at line 101 of file molecularStructure.h.

## Constructor & Destructor Documentation

## MolecularStructure() [1/2]

BALL::VIEW::MolecularStructure::MolecularStructure | ( | QWidget * | parent = 0,
|  | const char * | name = 0 )

Default Constructor. Calls registerWidget.

See also
  ModularWidget

## MolecularStructure() [2/2]

BALL::VIEW::MolecularStructure::MolecularStructure | ( | const MolecularStructure & | m | ) |

only needed for Python Interface, dont call it!

## ~MolecularStructure()

virtual BALL::VIEW::MolecularStructure::~MolecularStructure | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## addHydrogens

void BALL::VIEW::MolecularStructure::addHydrogens | ( |  | ) |

slot

Adds hydrogens. If selected molecular objects are available hydrogens will be created for each object in the selection list using the add_hydrogens processor of the FragmentDB. A CompositeMessage will be sent for each object in the selection list. The number of hydrogens created will be written into the Log object.

## buildBonds

void BALL::VIEW::MolecularStructure::buildBonds | ( |  | ) |

slot

Creates bonds. If selected molecular objects are available Bond objects will be created for each object in the selection list using the build_bonds processor of the FragmentDB. A CompositeMessage will be sent for each object in the selection list. The number of bonds created will be written into the Log object.

## buildEndcaps

void BALL::VIEW::MolecularStructure::buildEndcaps | ( |  | ) |

slot

Adds neutral end caps to a protein chain. This function runs our PeptideCapProcessor to replace the terminals by neutral end caps.

## buildPeptide

void BALL::VIEW::MolecularStructure::buildPeptide | ( |  | ) |

slot

Build a Peptide from a amino acid sequence.

## calculateFDPB

bool BALL::VIEW::MolecularStructure::calculateFDPB | ( | bool | show = true | ) |

slot

## calculateForceFieldEnergy

void BALL::VIEW::MolecularStructure::calculateForceFieldEnergy | ( |  | ) |

slot

Calculate the energy for the currently selected force field.

## calculateHBonds

void BALL::VIEW::MolecularStructure::calculateHBonds | ( |  | ) |

slot

Calculate the H-Bonds for a Protein.

## calculateRamachandranPlot

void BALL::VIEW::MolecularStructure::calculateRamachandranPlot | ( |  | ) |

slot

Calculate a Ramachandran Plot.

## calculateRMSD

virtual void BALL::VIEW::MolecularStructure::calculateRMSD | ( |  | ) |

virtual slot

Calculate the RMSD between two Molecules.

## calculateSecondaryStructure

virtual void BALL::VIEW::MolecularStructure::calculateSecondaryStructure | ( |  | ) |

virtual slot

Calculate the secondary structure for a protein.

## centerCamera

void BALL::VIEW::MolecularStructure::centerCamera | ( | Composite * | composite = 0 | ) |

slot

Centers the camera of Scene to the geometric center of the molecular objects in the selection list. A SceneMessage will be sent to inform the Scene.

## checkMenu()

virtual void BALL::VIEW::MolecularStructure::checkMenu | ( | MainControl & | main_control | ) |

virtual

Check the menu entries. The menus Select, Deselect, Add Hydrogens and Build Bonds will be enabled if the selection of molecular objects is not empty. The menu Focus camera will be enabled only if only one molecular object is in the selection list.

Reimplemented from BALL::VIEW::ModularWidget.

## checkResidue

virtual bool BALL::VIEW::MolecularStructure::checkResidue | ( |  | ) |

virtual slot

Check the residues

## chooseAmberFF

void BALL::VIEW::MolecularStructure::chooseAmberFF | ( |  | ) |

slot

Slot for a menu entry to select the AMBER force field.

## chooseCharmmFF

void BALL::VIEW::MolecularStructure::chooseCharmmFF | ( |  | ) |

slot

Slot for a menu entry to select the CHARMM force field.

## chooseForceField

void BALL::VIEW::MolecularStructure::chooseForceField | ( | Position | nr | ) |

slot

## chooseMMFF94

void BALL::VIEW::MolecularStructure::chooseMMFF94 | ( |  | ) |

slot

Slot for a menu entry to select the MMFF94 force field.

## createGridFromCameraDistance

virtual void BALL::VIEW::MolecularStructure::createGridFromCameraDistance | ( |  | ) |

virtual slot

## createGridFromDistance

virtual void BALL::VIEW::MolecularStructure::createGridFromDistance | ( |  | ) |

virtual slot

Create a RegularData3D instance with the distance from the geometric center.

## fetchPreferences()

virtual void BALL::VIEW::MolecularStructure::fetchPreferences | ( | INIFile & | inifile | ) |

virtual

Fetch the widgets preferences from the INIfile.

Parameters

  inifile | the INIFile that contains the required values

Reimplemented from BALL::VIEW::ModularWidget.

## generateCrystal

bool BALL::VIEW::MolecularStructure::generateCrystal | ( | bool | show = true | ) |

slot

Build a crystal packing for a loaded system.

## getAmberConfigurationDialog()

AmberConfigurationDialog & BALL::VIEW::MolecularStructure::getAmberConfigurationDialog | ( |  | ) |

Get an instance of an dialog to setup the AMBER forcefield.

## getAmberFF()

AmberFF & BALL::VIEW::MolecularStructure::getAmberFF | ( |  | ) |

Get the instance of the AMBER forcefield. The forcefield will be created, when this function is called the first time.

## getBondOrderDialog() [1/2]

AssignBondOrderConfigurationDialog & BALL::VIEW::MolecularStructure::getBondOrderDialog | ( |  | ) |

inline

Definition at line 220 of file molecularStructure.h.

## getBondOrderDialog() [2/2]

const AssignBondOrderConfigurationDialog & BALL::VIEW::MolecularStructure::getBondOrderDialog | ( |  | ) | const

inline

Definition at line 223 of file molecularStructure.h.

## getBondOrderResultsDialog() [1/2]

AssignBondOrderResultsDialog & BALL::VIEW::MolecularStructure::getBondOrderResultsDialog | ( |  | ) |

inline

Definition at line 226 of file molecularStructure.h.

## getBondOrderResultsDialog() [2/2]

const AssignBondOrderResultsDialog & BALL::VIEW::MolecularStructure::getBondOrderResultsDialog | ( |  | ) | const

inline

Definition at line 229 of file molecularStructure.h.

## getCharmmConfigurationDialog()

CharmmConfigurationDialog & BALL::VIEW::MolecularStructure::getCharmmConfigurationDialog | ( |  | ) |

Get an instance of an dialog to setup the CHARMM forcefield.

## getCharmmFF()

CharmmFF & BALL::VIEW::MolecularStructure::getCharmmFF | ( |  | ) |

Get the instance of the CHARMM forcefield. The forcefield will be created, when this function is called the first time.

## getFDPBDialog()

FDPBDialog * BALL::VIEW::MolecularStructure::getFDPBDialog | ( |  | ) |

inline

Definition at line 217 of file molecularStructure.h.

## getForceField()

ForceField & BALL::VIEW::MolecularStructure::getForceField | ( |  | ) |

Get the currently selected force field instance. This returns either a reference to the amber_ff_ member or to the charmm_ff_ member, depending on the value of use_amber_.

## getForceFieldID()

Position BALL::VIEW::MolecularStructure::getForceFieldID | ( |  | ) |

Get the force_field_id of the currently selected ForceField

## getMDSimulationDialog()

MolecularDynamicsDialog & BALL::VIEW::MolecularStructure::getMDSimulationDialog | ( |  | ) |

inline

Definition at line 211 of file molecularStructure.h.

## getMinimizationDialog()

MinimizationDialog & BALL::VIEW::MolecularStructure::getMinimizationDialog | ( |  | ) |

inline

Definition at line 214 of file molecularStructure.h.

## getMMFF94()

MMFF94 & BALL::VIEW::MolecularStructure::getMMFF94 | ( |  | ) |

## getMMFF94ConfigurationDialog()

MMFF94ConfigurationDialog & BALL::VIEW::MolecularStructure::getMMFF94ConfigurationDialog | ( |  | ) |

## initializeWidget()

virtual void BALL::VIEW::MolecularStructure::initializeWidget | ( | MainControl & | main_control | ) |

virtual

Initialize the popup menus for this Widget. This method is called automatically immediately before the main application is started by MainControl::show().

Parameters

  main_control | the MainControl object to be initialized

See also
  finalizeWidget

Reimplemented from BALL::VIEW::ModularWidget.

## mapProteins

virtual void BALL::VIEW::MolecularStructure::mapProteins | ( |  | ) |

virtual slot

Map two Proteins and apply the resulting transformation matrix.

## MDSimulation

void BALL::VIEW::MolecularStructure::MDSimulation | ( | bool | show_dialog_ = true | ) |

slot

Perfomr a molecular dynamics simulation with the currently selected force field.

## onNotify()

virtual void BALL::VIEW::MolecularStructure::onNotify | ( | Message * | message | ) |

virtual

Handles messages sent by other registered ConnectionObject objects. Converts CompositeMessage if the retrieved Composite object is kind of AtomContainer and applies molecular properties to it (like normalize_names and build_bonds).

Parameters

  message | the pointer to the message that should be processed

See also
  CompositeMessage
  GeometricObjectSelectionMessage
  MolecularTaskMessage

Reimplemented from BALL::VIEW::ConnectionObject.

## runBondOrderAssignment

void BALL::VIEW::MolecularStructure::runBondOrderAssignment | ( | bool | show_dialog = true | ) |

slot

Assigns bond orders. If a single selected molecular object is available Bond Orders will be set for each bond object of the selected AtomContainer using the assign_bond_order processor. A CompositeMessage will be sent for the object in the selection list. The number of bond orders changed will be written into the Log object.

## runMinimization

void BALL::VIEW::MolecularStructure::runMinimization | ( | bool | show_dialog_ = true | ) |

slot

Run a energy minization with the currently selected force field.

## setupForceField

void BALL::VIEW::MolecularStructure::setupForceField | ( |  | ) |

slot

Show a dialog to setup the currently selected force field.

## showAmberForceFieldOptions

void BALL::VIEW::MolecularStructure::showAmberForceFieldOptions | ( |  | ) |

slot

Show the dialog to setup the AMBER force field.

## showBondOrderAssignmentResults

void BALL::VIEW::MolecularStructure::showBondOrderAssignmentResults | ( | AssignBondOrderProcessor & | bop | ) |

slot

Shows the results of the given BondOrderAssigner. All bond order assignment sets found by the given BondOrderAssigner will be presented as structural sketch, additional scoring information is provided by click on the entry. A single assignment can either be applied to the selected AtomContainer, or a copy of the original system with the bond order assignment of the current result is added to the Structure list.

## showCharmmForceFieldOptions

void BALL::VIEW::MolecularStructure::showCharmmForceFieldOptions | ( |  | ) |

slot

Show the dialog to setup the CHARMM force field.

## showMMFF94ForceFieldOptions

void BALL::VIEW::MolecularStructure::showMMFF94ForceFieldOptions | ( |  | ) |

slot

## writePreferences()

virtual void BALL::VIEW::MolecularStructure::writePreferences | ( | INIFile & | inifile | ) |

virtual

Writes the widgets preferences to the INIFile.

Parameters

  inifile | the INIFile that contains the needed values

Reimplemented from BALL::VIEW::ModularWidget.